CREATE PROCEDURE [dbo].[SP_Insert_PartMaster] 
AS
BEGIN

-- ====================================================
-- Author:		FID.Iman
-- Create date: 2013.05.03
-- Description:	To move data from TB_T_SUPPLIER_PART 
--				to TB_M_SUPPLIER_PART
--              delete previous exist data then insert new one.
--              Copy data from TB_M_SUPPLIER to
--				TB_M_PART_PROC where TB_M_SUPPLIER.PART_NO
--              NOT IN TB_M_PART_PROC where PACKAGING_TYPE <> 'Manual'
-- Ver:  1.0    created.
-- Ver:  1.1    Modify Fid.Teddy
-- ====================================================

	SET NOCOUNT ON;
    
    DECLARE
    @L_V_SUPPLIER_CD		varchar(4),
	@L_V_SUPPLIER_PLANT		varchar(1),
	@L_V_SUPPLIER_SHIPPING	varchar(3),
	@L_V_REC_COMP_CD		varchar(4),
	@L_V_REC_PLANT_CD		varchar(1),
	@L_V_REC_DOCK_CD		varchar(2),
	@L_V_INHOUSE_ROUTING	varchar(6),
	@L_V_PART_NO			varchar(12),
	@L_V_TIME_FROM			varchar(8),
	@L_V_TIME_TO			varchar(8),
	@L_V_PART_NAME			varchar(40),
	@L_V_LIFE_CYCLE_CD		char(1),
	@L_V_TEAM_MEMBER		varchar(20),
	@L_V_SERIES_NAME		varchar(20),
	@L_V_ORDER_METHOD		varchar(1),
	@L_V_BC_REF_FLAG		varchar(1),
	@L_V_KANBAN_NO			varchar(4),
	@L_V_KANBAN_QTY			varchar(5),
	@L_V_VENDOR_SHARE_FLAG	varchar(1),
	@L_V_VENDOR_SHARE_VALUE	varchar(7),
	@L_V_PC_LEAD_TIME		varchar(4),
	@L_V_PC_SAFETY_TIME		varchar(4),
	@L_V_LINE_LEAD_TIME		varchar(4),
	@L_V_LINE_SAFETY_TIME	varchar(4),
	@L_V_SAFETY_PCS			varchar(7),
	@L_V_PCK_TYPE			varchar(18),
	@L_V_PARTS_WEIGHT		varchar(8),
	@L_V_PACK_PER_CONT		varchar(5),
	@L_V_SUPP_M				varchar(4),
	@L_V_SUPP_PLANT_M		varchar(1),
	@L_V_SUPP_SHIPPING_M	varchar(3),
	@L_V_REC_COMP_M			varchar(4),
	@L_V_REC_PLANT_M		varchar(1),
	@L_V_REC_DOCK_M			varchar(2),
	@L_V_INHOUSE_M			varchar(6),
	@L_V_PART_M				varchar(12),
	@L_V_TIME_FROM_M		varchar(8),
	@L_V_TIME_TO_M			varchar(8)

    
   -- Delete existing data
   --- Confirm by checking file : GBF4S40M.DS06O100.X0000001.20131206063219, Part No : 633100D690A0  
    Delete TB_M_SUPPLIER_PART;
   -- cursor for loop 
   DECLARE cur_part CURSOR FOR
	SELECT  a.SUPPLIER_CD,  -- 1
			a.SUPPLIER_PLANT,  --2
			a.SUPPLIER_SHIPPING,  --3
			a.REC_COMP_CD,  --4
			a.REC_PLANT_CD,  --5
			a.REC_DOCK_CD,  --6
			a.INHOUSE_ROUTING,  --7
			a.PART_NO,  --8
			a.TIME_FROM,  --9
			a.TIME_TO,  --10
			a.PART_NAME,  --11
			a.LIFE_CYCLE_CD,  --12
			a.TEAM_MEMBER,  --13
			a.SERIES_NAME,  --14
			a.ORDER_METHOD,  --15
			a.BC_REF_FLAG,  --16
			a.KANBAN_NO,  --17
			a.KANBAN_QTY,  --18
			a.VENDOR_SHARE_FLAG,  --19
			a.VENDOR_SHARE_VALUE,  --20
			a.PC_LEAD_TIME,  --21
			a.PC_SAFETY_TIME,  --22
			a.LINE_LEAD_TIME,  --23
			a.LINE_SAFETY_TIME,  --24
			a.SAFETY_PCS,  --25
			a.PCK_TYPE,  --26
			a.PARTS_WEIGHT,  --27
			a.PACK_PER_CONT,  --28
			b.SUPPLIER_CD   SUPP_M,   --29
			b.SUPPLIER_PLANT   SUPP_PLANT_M,  --30
			b.SUPPLIER_SHIPPING   SUPP_SHIPPING_M,  --31 
			b.REC_COMP_CD   REC_COMP_CD_M,   --32
			b.REC_PLANT_CD   REC_PLANT_CD_M,  --33
			b.REC_DOCK_CD   REC_DOCK_CD_M,  --34
			b.INHOUSE_ROUTING   INHOUSE_ROUTING_M,  --35
			b.PART_NO   PART_NO_M,  --36
			b.TIME_FROM   TIME_FROM_M,  --37	
			b.TIME_TO  TIME_TO_M  -- 38		
	FROM TB_T_SUPPLIER_PART a
	LEFT OUTER JOIN TB_M_SUPPLIER_PART b ON
	  a.SUPPLIER_CD = b.SUPPLIER_CD
	  AND a.SUPPLIER_PLANT = b.SUPPLIER_PLANT
	  AND a.SUPPLIER_SHIPPING = b.SUPPLIER_SHIPPING
	  AND a.REC_COMP_CD = b.REC_COMP_CD
	  AND a.REC_PLANT_CD = b.REC_PLANT_CD
	  AND a.REC_DOCK_CD = b.REC_DOCK_CD
	  AND a.INHOUSE_ROUTING = b.INHOUSE_ROUTING
	  AND a.PART_NO = b.PART_NO
	  AND a.TIME_FROM = b.TIME_FROM
    ORDER BY PART_NO 
	
	-- open cursor 
	OPEN cur_part
	FETCH cur_part INTO 
    	@L_V_SUPPLIER_CD,	--1
        @L_V_SUPPLIER_PLANT,   --2
		@L_V_SUPPLIER_SHIPPING,  --3
		@L_V_REC_COMP_CD,  --4
		@L_V_REC_PLANT_CD,  --5
		@L_V_REC_DOCK_CD,  --6
		@L_V_INHOUSE_ROUTING,  --7
		@L_V_PART_NO,  --8
		@L_V_TIME_FROM,  --9
		@L_V_TIME_TO,  --10
		@L_V_PART_NAME,  --11
		@L_V_LIFE_CYCLE_CD,  --12
		@L_V_TEAM_MEMBER,  --13
		@L_V_SERIES_NAME,  --14
		@L_V_ORDER_METHOD, --15
		@L_V_BC_REF_FLAG,  --16
		@L_V_KANBAN_NO,  --17
		@L_V_KANBAN_QTY,  --18
		@L_V_VENDOR_SHARE_FLAG, --19
		@L_V_VENDOR_SHARE_VALUE,  --20
		@L_V_PC_LEAD_TIME,  --21
		@L_V_PC_SAFETY_TIME,  --22
		@L_V_LINE_LEAD_TIME,  --23
		@L_V_LINE_SAFETY_TIME,  --24
		@L_V_SAFETY_PCS,  --25
		@L_V_PCK_TYPE,  --26
		@L_V_PARTS_WEIGHT,  --27
		@L_V_PACK_PER_CONT,  --28
		@L_V_SUPP_M,  --29
		@L_V_SUPP_PLANT_M,  --30
		@L_V_SUPP_SHIPPING_M,  --31
		@L_V_REC_COMP_M,  --32
		@L_V_REC_PLANT_M,  --33
		@L_V_REC_DOCK_M,  --34
		@L_V_INHOUSE_M,  --35
		@L_V_PART_M,  --36
		@L_V_TIME_FROM_M,  --37
		@L_V_TIME_TO_M
	WHILE @@FETCH_STATUS = 0
	
	BEGIN
		--Check if Part_m empty (master not exist) then insert
		IF (ISNULL(@L_V_PART_M,'@#') = '@#') OR
			(ISNULL(@L_V_SUPP_M,'@#') <>  ISNULL(@L_V_SUPPLIER_CD ,'@#')OR 
			 ISNULL(@L_V_SUPP_PLANT_M,'@#') <> ISNULL(@L_V_SUPPLIER_PLANT,'@#') OR
			 ISNULL(@L_V_SUPP_SHIPPING_M,'@#') <> ISNULL(@L_V_SUPPLIER_SHIPPING,'@#') OR
			 ISNULL(@L_V_REC_COMP_M,'@#') <>  ISNULL(@L_V_REC_COMP_CD,'@#') OR
			 ISNULL(@L_V_REC_PLANT_M,'@#') <> ISNULL(@L_V_REC_PLANT_CD,'@#') OR
			 ISNULL(@L_V_REC_DOCK_M,'@#') <> ISNULL(@L_V_REC_DOCK_CD,'@#')  OR
			 ISNULL(@L_V_INHOUSE_M,'@#')  <> ISNULL(@L_V_INHOUSE_ROUTING,'@#')  OR
			 ISNULL(@L_V_PART_M,'@#')  <>  ISNULL(@L_V_PART_NO,'@#') OR
			 ISNULL(@L_V_TIME_FROM_M,'@#')  <> ISNULL(@L_V_TIME_FROM,'@#') )
			 
		   BEGIN
		       -- Insert data from temp table to Master table
				Insert into TB_M_SUPPLIER_PART
				(
					SUPPLIER_CD,   --1
					SUPPLIER_PLANT,  --2
					SUPPLIER_SHIPPING,  --3
					REC_COMP_CD,  --4
					REC_PLANT_CD,  --5
					REC_DOCK_CD,  --6
					INHOUSE_ROUTING,  --7
					PART_NO,  --8
					TIME_FROM,  --9
					TIME_TO,  --10
					PART_NAME,  --11
					LIFE_CYCLE_CD,  --12
					TEAM_MEMBER,  --13
					SERIES_NAME,  --14
					ORDER_METHOD,  --15
					BC_REF_FLAG,  --16
					KANBAN_NO,  --17
					KANBAN_QTY,  --18
					VENDOR_SHARE_FLAG,  --19
					VENDOR_SHARE_VALUE,  --20
					PC_LEAD_TIME,  --21
					PC_SAFETY_TIME,  --22
					LINE_LEAD_TIME,  --23
					LINE_SAFETY_TIME,  --24
					SAFETY_PCS,  --25
					PCK_TYPE,  --26
					PART_WEIGHT,  --27
					PACK_PER_CONTAINER,  --28
					CREATED_BY,  --29
					CREATED_DT, --30
					AUDIO_FLAG --31
				)
				VALUES (
					@L_V_SUPPLIER_CD,	--1
					@L_V_SUPPLIER_PLANT,   --2
					@L_V_SUPPLIER_SHIPPING,  --3
					@L_V_REC_COMP_CD,  --4
					@L_V_REC_PLANT_CD,  --5
					@L_V_REC_DOCK_CD,  --6
					@L_V_INHOUSE_ROUTING,  --7
					@L_V_PART_NO,  --8
					@L_V_TIME_FROM,  --9
					@L_V_TIME_TO,  --10
					@L_V_PART_NAME,  --11
					@L_V_LIFE_CYCLE_CD,  --12
					@L_V_TEAM_MEMBER,  --13
					@L_V_SERIES_NAME,  --14
					@L_V_ORDER_METHOD, --15
					@L_V_BC_REF_FLAG,  --16
					@L_V_KANBAN_NO,  --17
					@L_V_KANBAN_QTY,  --18
					@L_V_VENDOR_SHARE_FLAG, --19
					@L_V_VENDOR_SHARE_VALUE,  --20
					@L_V_PC_LEAD_TIME,  --21
					@L_V_PC_SAFETY_TIME,  --22
					@L_V_LINE_LEAD_TIME,  --23
					@L_V_LINE_SAFETY_TIME,  --24
					@L_V_SAFETY_PCS,  --25
					@L_V_PCK_TYPE,  --26
					@L_V_PARTS_WEIGHT,  --27
					@L_V_PACK_PER_CONT,  --28
					'SYSTEM',	--29
					GETDATE(), --30
					'' )
		    END 
		   
		-- if master exist
		ELSE IF @L_V_TIME_TO_M < @L_V_TIME_TO
		    BEGIN
		       UPDATE TB_M_SUPPLIER_PART 
		       SET TIME_TO = @L_V_TIME_TO,
					PART_NAME = @L_V_PART_NAME,
					LIFE_CYCLE_CD = @L_V_LIFE_CYCLE_CD, 
					TEAM_MEMBER = @L_V_TEAM_MEMBER, 
					SERIES_NAME = @L_V_SERIES_NAME,
					ORDER_METHOD = @L_V_ORDER_METHOD,
					BC_REF_FLAG = @L_V_BC_REF_FLAG,
					KANBAN_NO = @L_V_KANBAN_NO,
					KANBAN_QTY = @L_V_KANBAN_QTY,
					VENDOR_SHARE_FLAG = @L_V_VENDOR_SHARE_FLAG,
					VENDOR_SHARE_VALUE = @L_V_VENDOR_SHARE_VALUE,
					PC_LEAD_TIME = @L_V_PC_LEAD_TIME,
					PC_SAFETY_TIME = @L_V_PC_SAFETY_TIME,
					LINE_LEAD_TIME = @L_V_LINE_LEAD_TIME, 
					LINE_SAFETY_TIME = @L_V_LINE_SAFETY_TIME,
					SAFETY_PCS = @L_V_SAFETY_PCS,
					PCK_TYPE = @L_V_PCK_TYPE,
					PART_WEIGHT = @L_V_PARTS_WEIGHT, 
					PACK_PER_CONTAINER = @L_V_PACK_PER_CONT, 
					CHANGED_BY = 'SYSTEM',
					CHANGED_DT = getdate()
		       WHERE SUPPLIER_CD = @L_V_SUPP_M
				AND SUPPLIER_PLANT = @L_V_SUPP_PLANT_M
				AND SUPPLIER_SHIPPING = @L_V_SUPP_SHIPPING_M
				AND REC_COMP_CD = @L_V_REC_COMP_M
				AND REC_PLANT_CD = @L_V_REC_PLANT_M
				AND REC_DOCK_CD = @L_V_REC_DOCK_M
				AND INHOUSE_ROUTING = @L_V_INHOUSE_M
				AND PART_NO = @L_V_PART_M
				AND TIME_FROM = @L_V_TIME_FROM_M
		      
		    END

        -- next fetch
		FETCH cur_part INTO 
    			@L_V_SUPPLIER_CD, @L_V_SUPPLIER_PLANT, @L_V_SUPPLIER_SHIPPING, @L_V_REC_COMP_CD,  --4
				@L_V_REC_PLANT_CD, @L_V_REC_DOCK_CD, @L_V_INHOUSE_ROUTING, @L_V_PART_NO,  --8
				@L_V_TIME_FROM, @L_V_TIME_TO, @L_V_PART_NAME,  @L_V_LIFE_CYCLE_CD,  --12
				@L_V_TEAM_MEMBER,  @L_V_SERIES_NAME, @L_V_ORDER_METHOD, @L_V_BC_REF_FLAG,  --16
				@L_V_KANBAN_NO, @L_V_KANBAN_QTY, @L_V_VENDOR_SHARE_FLAG, @L_V_VENDOR_SHARE_VALUE,  --20
				@L_V_PC_LEAD_TIME, @L_V_PC_SAFETY_TIME, @L_V_LINE_LEAD_TIME, @L_V_LINE_SAFETY_TIME,  --24
				@L_V_SAFETY_PCS, @L_V_PCK_TYPE, @L_V_PARTS_WEIGHT, @L_V_PACK_PER_CONT,  --28
				@L_V_SUPP_M, @L_V_SUPP_PLANT_M, @L_V_SUPP_SHIPPING_M, @L_V_REC_COMP_M,  --32
				@L_V_REC_PLANT_M, @L_V_REC_DOCK_M, @L_V_INHOUSE_M, @L_V_PART_M,  --36
				@L_V_TIME_FROM_M, @L_V_TIME_TO_M  --38
	END
	CLOSE cur_part
	DEALLOCATE cur_part
    
     -- delete temp table;
     delete TB_T_SUPPLIER_PART ;
    
    ----- Modify Fid.Teddy 20May2014 -----------

	--delete lock that created in ascii
	DELETE FROM TB_T_LOCK WHERE FUNCTION_NO = 'GBF4S40M'


       
    ----- Insert TB_M_SUPPLIER TO TB_PART_PROC ---------------
    DECLARE
    @SUPPLIER_CD varchar(4),
	@SUPPLIER_PLANT varchar(1),
	@SUPPLIER_SHIPPING varchar(3),
	@REC_COMP_CD varchar(4),
	@REC_PLANT_CD char(1),
	@REC_DOCK_CD varchar(2),
	@INHOUSE_ROUTING varchar(6),
	@PART_NO varchar(12)  ,
	@TIME_FROM varchar(8)  ,
	@TIME_TO varchar(8)  ,
	@PART_NAME varchar (40)  ,
	@LIFE_CYCLE_CD int  ,
	@TEAM_MEMBER varchar(20)  ,
	@SERIES_NAME varchar(20)  ,
	@ORDER_METHOD varchar(1)  ,
	@BC_REF_FLAG varchar(1)  ,
	@KANBAN_NO varchar(4)  ,
	@KANBAN_QTY int  ,
	@VENDOR_SHARE_FLAG varchar(1)  ,
	@VENDOR_SHARE_VALUE varchar(7)  ,
	@PC_LEAD_TIME int  ,
	@PC_SAFETY_TIME int  ,
	@LINE_LEAD_TIME int  ,
	@LINE_SAFETY_TIME int ,
	@SAFETY_PCS int ,
	@PCK_TYPE varchar(20) ,
	@PART_WEIGHT int ,
	@PACK_PER_CONTAINER int
	
    BEGIN 
	/*** INSERT TB_M_PART_PROC FROM TB_M_SUPPLIER_PART ***/
	INSERT OPENQUERY (IPMS_PROD, 'SELECT SUPLIER_CD,
						 SUPPLIER_PLANT_CD, 
						 SUPPLIER_SHIP_DOCK_CD, 
						 RECEIVING_COY_CD, 
						 RECEIVING_COY_PLANT_CD, 
						 RECEIVING_COY_DOCK_CD, 
						 INHOUSE_ROUTE,
						 PART_NO,
						 TC_FROM,
						 TC_TO,
						 PART_NAME,
						 LIFE_CYCLE_CD,
						 RELATED_PIC,
						 SERIES_NAME,
						 ORDER_METHOD,
						 B_VS_C_FLAG,
						 KANBAN_NO,
						 PCS_PER_KANBAN,
						 SUPPLIER_SHARE_FLAG,
						 SUPPLIER_SHARE_VALUE,
						 DELIVERY_LT_TO_PC,
						 PC_SAFETY_TIME,
						 DELIVERY_LT_TO_LINE,
						 LINE_SAFETY_TIME,
						 SAFETY_PCS,
						 PACKAGING_TYPE,
						 PART_WEIGHT,
						 PACKING_PER_CONTAINER 
						 FROM TB_M_PART_PROC')					 
	SELECT IPCS.SUPPLIER_CD, IPCS.SUPPLIER_PLANT, IPCS.SUPPLIER_SHIPPING, IPCS.REC_COMP_CD, IPCS.REC_PLANT_CD, 
    IPCS.REC_DOCK_CD, IPCS.INHOUSE_ROUTING, IPCS.PART_NO, IPCS.TIME_FROM, IPCS.TIME_TO, IPCS.PART_NAME, 
    IPCS.LIFE_CYCLE_CD, IPCS.TEAM_MEMBER, IPCS.SERIES_NAME, IPCS.ORDER_METHOD, IPCS.BC_REF_FLAG, 
    IPCS.KANBAN_NO, IPCS.KANBAN_QTY, IPCS.VENDOR_SHARE_FLAG, IPCS.VENDOR_SHARE_VALUE,IPCS.PC_LEAD_TIME, 
    IPCS.PC_SAFETY_TIME, IPCS.LINE_LEAD_TIME, IPCS.LINE_SAFETY_TIME, IPCS.SAFETY_PCS, 
    IPCS.PCK_TYPE, IPCS.PART_WEIGHT, IPCS.PACK_PER_CONTAINER
    FROM IPPCS_PROD.dbo.TB_M_SUPPLIER_PART IPCS 
    WHERE  NOT EXISTS ( 
    SELECT * FROM openquery(IPMS_PROD,'SELECT 
    SUPLIER_CD, 
	SUPPLIER_PLANT_CD, 
	SUPPLIER_SHIP_DOCK_CD, 
	RECEIVING_COY_CD, 
	RECEIVING_COY_PLANT_CD, 
	RECEIVING_COY_DOCK_CD, 
	INHOUSE_ROUTE, 
	PART_NO, 
	TC_FROM, 
	PACKAGING_TYPE
    FROM TB_M_PART_PROC') IPMS
    WHERE 
    IPCS.SUPPLIER_CD = IPMS.SUPLIER_CD
    AND   IPCS.SUPPLIER_PLANT = IPMS.SUPPLIER_PLANT_CD
    AND   IPCS.SUPPLIER_SHIPPING = IPMS.SUPPLIER_SHIP_DOCK_CD
    AND   IPCS.REC_COMP_CD  =  IPMS.RECEIVING_COY_CD
    AND   IPCS.REC_PLANT_CD = IPMS.RECEIVING_COY_PLANT_CD 
    AND	  IPCS.REC_DOCK_CD =  IPMS.RECEIVING_COY_DOCK_CD 
    AND   IPCS.INHOUSE_ROUTING = IPMS.INHOUSE_ROUTE 
    AND   IPCS.TIME_FROM = IPMS.TC_FROM
    AND   IPCS.PART_NO = IPMS.PART_NO
    )
        

    END
     
END

/****** Object:  Table [dbo].[TB_R_DELIVERY_CTL_SUPPLIERDOCK]    Script Date: 02/15/2013 18:08:22 ******/

